#!/usr/bin/tclsh

# Wir wollens GENAU!
set tcl_precision 17

# Eingabedatei: Wir lesen vom Standart-Input-Stream
set in stdin

# Kommandozeile auswerten.
# Wieviele Anfangswerte wollen wir berlesen? 
set skip $argv
if ![string length $skip] {
    set skip 0
}

set n -$skip

# Gnuplotdatei auswerten: Jede Zeile enthlt zwei Werte x und y
while {1} {
    if [eof $in] {
	break
    }
    incr n

    gets $in a
    if {[scan $a "%g %g" x($n) y($n)] == -1} {
	set n [expr $n-1]
    }
}

# Summen fr die Lineare Regression berechnen

# Summe aller x- bzw. y-Werte
set sumx 0.0
set sumy 0.0

# Summe der Quadrate der x- bzw. y-Werte
set sumxx 0.0
set sumyy 0.0

# Summe der Quadrate der xy-Werte
set sumxy 0.0

for {set i 1} {$i <= $n} {incr i} { 
    set sumx [expr $sumx+$x($i)]
    set sumy [expr $sumy+$y($i)]

    set sumxx [expr $sumxx+$x($i)*$x($i)]
    set sumyy [expr $sumyy+$y($i)*$y($i)]

    set sumxy [expr $sumxy+$x($i)*$y($i)]
}

# Lineare Regression anwenden 
# (Quelle: Anleitung zu unserem Casio-Taschenrechner... ;-)

set B [expr ($n.0*$sumxy-$sumx*$sumy)/($n.0*$sumxx-$sumx*$sumx)]
set A [expr ($sumy - $B*$sumx)/$n.0]
set r [expr ($n.0*$sumxy-$sumx*$sumy)/\
	   sqrt(($n.0*$sumxx-$sumx*$sumx)*($n.0*$sumyy-$sumy*$sumy))]

# Das Ergebnis ausgeben
puts "y = $B x + $A, Relativer Fehler: r = $r"
puts "Mittelwerte: x: [expr $sumx/$n.0], y: [expr $sumy/$n.0]"

